## schroot 1.6.8

=== bin/CMakeLists.txt ===
# Copyright © 2004-2013  Roger Leigh <rleigh@debian.org>
#
# schroot is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# schroot is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
#
#####################################################################

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_subdirectory(dchroot)
add_subdirectory(dchroot-dsa)
add_subdirectory(schroot)
add_subdirectory(schroot-base)
add_subdirectory(schroot-listmounts)
add_subdirectory(schroot-mount)

=== doc/CMakeLists.txt ===
# Copyright © 2004-2013  Roger Leigh <rleigh@debian.org>
#
# schroot is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# schroot is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
#
#####################################################################

if(BUILD_DOXYGEN)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/sbuild.dox.cmake
                 ${CMAKE_CURRENT_BINARY_DIR}/sbuild.dox @ONLY)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/schroot.dox.cmake
                 ${CMAKE_CURRENT_BINARY_DIR}/schroot.dox @ONLY)

  add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/sbuild.log
                     COMMAND ${CMAKE_COMMAND} -E remove_directory sbuild
                     COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/sbuild.dox
                     COMMAND ${CMAKE_COMMAND} -E echo "══════════ UNDOCUMENTED CODE ══════════"
                     COMMAND cat ${CMAKE_CURRENT_BINARY_DIR}/sbuild.log
                     COMMAND ${CMAKE_COMMAND} -E echo "═════════ END UNDOCUMENTED CODE ═══════"
                     DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/sbuild.dox)

  add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/schroot.log
                     COMMAND ${CMAKE_COMMAND} -E remove_directory schroot
                     COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/schroot.dox
                     COMMAND ${CMAKE_COMMAND} -E echo "══════════ UNDOCUMENTED CODE ══════════"
                     COMMAND cat ${CMAKE_CURRENT_BINARY_DIR}/schroot.log
                     COMMAND ${CMAKE_COMMAND} -E echo "═════════ END UNDOCUMENTED CODE ═══════"
                     DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/schroot.dox)

  add_custom_target(doc DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/sbuild.log ${CMAKE_CURRENT_BINARY_DIR}/schroot.log)
endif(BUILD_DOXYGEN)

=== etc/CMakeLists.txt ===
# Copyright © 2004-2013  Roger Leigh <rleigh@debian.org>
#
# schroot is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# schroot is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
#
#####################################################################

set(schroot_sysconf_data
    schroot.conf)

install(FILES ${schroot_sysconf_data}
        DESTINATION ${SCHROOT_SYSCONF_DIR})

set(files
    copyfiles
    fstab
    nssdatabases)

set(profiles
    buildd
    default
    desktop
    minimal
    sbuild)

set(arches
    ${SBUILD_PLATFORM})

foreach(profile ${profiles})
  foreach(file ${files})
    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/profiles/${profile}")
    set(output_file "${CMAKE_CURRENT_BINARY_DIR}/profiles/${profile}/${file}")
    foreach(arch ${arches})
      if(EXISTS ${output_file})
        file(REMOVE ${output_file})
      endif(EXISTS ${output_file})
      foreach(source_file
        ${CMAKE_CURRENT_SOURCE_DIR}/profile-templates/all/all/${file}
        ${CMAKE_CURRENT_SOURCE_DIR}/profile-templates/all/${arch}/${file}
        ${CMAKE_CURRENT_SOURCE_DIR}/profile-templates/${profile}/all/${file}
        ${CMAKE_CURRENT_SOURCE_DIR}/profile-templates/${profile}/${arch}/${file})
        if(EXISTS ${source_file})
          file(READ ${source_file} content)
          if(EXISTS ${source_file})
            file(APPEND ${output_file} ${content})
          else(EXISTS ${source_file})
            file(WRITE ${output_file} ${content})
          endif(EXISTS ${source_file})
        endif(EXISTS ${source_file})
      endforeach(source_file)
      if(EXISTS ${output_file})
        message(STATUS "Generated schroot profile ${profile}/${file}")
        install(FILES ${output_file}
                DESTINATION ${SCHROOT_SYSCONF_DIR}/${profile})
      endif(EXISTS ${output_file})
    endforeach(arch)
  endforeach(file)
endforeach(profile)

add_subdirectory(pam)
add_subdirectory(bash_completion)
add_subdirectory(setup.d)

=== etc/bash_completion/CMakeLists.txt ===
# Copyright © 2004-2013  Roger Leigh <rleigh@debian.org>
#
# schroot is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# schroot is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
#
#####################################################################

set(bash_completion_data schroot)

install(FILES ${bash_completion_data}
        DESTINATION ${bash_completion_dir})

## schroot 1.3.0~rc1-45-0geofft1

=== debian/changelog ===
schroot (1.3.0~rc1-45-0geofft1) karmic; urgency=low

  * git pull to 11ea993.

 -- Geoffrey Thomas <geofft@mit.edu>  Sat, 10 Oct 2009 03:45:19 -0400

schroot (1.3.0~rc1-35-1) karmic; urgency=low

  * Decrease Debian version number.
  * Fix debian/control to build on Jaunty.
  * Fix configure.ac to build on Jaunty.

 -- Geoffrey Thomas <geofft@mit.edu>  Sat, 12 Sep 2009 01:35:55 -0400

schroot (1.3.0-1) experimental; urgency=low

  [Roger Leigh]
  * New upstream development release.
  * debian/control:
    - libsbuild-dev is in section libdevel.
    - Build-Depend on Boost 1.38.
    - Build-Depend on debhelper v7.
    - Build-Depend on doxygen.
    - Update to Standards Version 3.8.2.
  * debian/compat: Use debhelper v7 compatibility mode.
  * debian/rules:
    - Use dh_prep in place of dh_clean -k.  Remove debian/install
      after running dh_prep.
    - Configure with --with-bash-completion-dir.
    - Configure with --enable-doxygen.
    - Split configure invocation onto multiple lines.
    - Only mkdir debian/build if it doesn't already exist.
  * schroot: Install bash completion.
  * schroot.conf: Use current distribution names (lenny and squeeze
    in place of sarge and etch (Closes: #516272).
  * sbuild-session.cc: Fix potential memory leak in is_group_member()
    (Closes: #517223).
  * schroot-script-config.5, schroot-setup.5: Fix typos
    (Closes: #517041).  Thanks to Loïc Minier.
  * schroot now ignores backup files (including dpkg conffile backups)
    in /etc/schroot/chroot.d (Closes: #513307, #496629).
  * mount-defaults: Bind mount /dev/shm rather than creating a new
    tmpfs inside the chroot to avoid potention denial of service
    attacks (Closes: #526788).  Thanks to Aurelien Jarno.
  * etc/setup.d/05lvm: Reorder lvm snapshot options to make more
    flexible (Closes: #494481).  Thanks to Timothy G Abbott for this
    suggestion.
  * If user authentication fails, return a nonzero exit status
    (Closes: #545706).  Thanks to Nelson Elhage for identifying this
    bug.

  [Jan-Marek Glogowski]
  * debian/control:
    - Build-Depends: Add doxygen and graphviz.
    - schroot-dbg: Add new package containing debugging symbols
      for schroot, dchroot and dchroot-dsa.  Only allow installation
      of correct package versions.
    - schroot-doc: Don't depend on pkg-config, suggest libsbuild-dev.
  * debian/rules:
    - Add check rule to run unit tests at install time.
    - Use "$(MAKE) -C" in place of explicit "cd && make".

 -- Roger Leigh <rleigh@debian.org>  Mon, 14 Sep 2009 20:12:48 +0100

schroot (1.2.2-1) unstable; urgency=low

  * New upstream stable release.
  * Compile and link with POSIX thread support (Closes: #520713).
    libstdc++ std::tr1::shared_ptr does not appear to work
    correctly on Alpha without -pthread, failing during shared_ptr
    construction or assignment due to an failed internal glibc
    assertion while locking a pthread mutex.

 -- Roger Leigh <rleigh@debian.org>  Sun, 22 Mar 2009 16:56:38 +0000

schroot (1.2.1-1) unstable; urgency=low

  * New upstream stable release.
  * debian/control:
    - Upgrade to Standards-Version 3.8.0.
    - Don't Build-Depend upon -1 Debian revisions.
  * po:
    - Update eu translation (Closes: #479498).  Thanks to Piarres Beobide.
    - Update fr translation (Closes: #481648).  Thanks to Nicolas François.
    - Update pt translation (Closes: #480640).  Thanks to Pedro Ribeiro.
    - Update vi translation (Closes: #479750).  Thanks to Clytie Siddall.
    - Add zh_CN translation (Closes: #480174).  Thanks to LI Daobing (李道兵).
    - Update zh_CN translation.  Thanks to Ji ZhengYu.
  * sbuild/sbuild-lock.cc: Order of "struct flock" members is not assumed,
    for GNU/kFreeBSD portability (Closes: #485637).  Thanks to Petr
    Salinger.
  * schroot.1.in, schroot.conf.5.in: Document /etc/schroot/chroot.d
    (Closes: #487588).
  * setup/10mount: Don't clear mount options for LVM snapshots
    (Closes: #488726).
  * New "loopback" chroot type allows loopback mounting of files
    (Closes: #475515).

 -- Roger Leigh <rleigh@debian.org>  Sat, 05 Jul 2008 11:41:33 +0100

schroot (1.2.0-1) unstable; urgency=low

  * New upstream stable release.
  * Add eu translation (Closes: #462164).
  * Updated pt translation (Closes: #464053).
  * debian/control:
    - libsbuild-dev is in section libdevel.
    - Add libboost-filesystem-dev to Build-Depends.
    - Bump Standards-Version to 3.7.3.
  * debian/libsbuild-doc.doc-base: Use section Programming/C++
  * Setup and exec scripts check for existence and validity of
    script-config file options, as well as script-config itself, and exit with
    an error status and message if incorrect (Closes: #462680).
  * Reading the configuration no longer uses O_NOFOLLOW (Closes: #476332).
    Thanks to Timothy G Abbott.
  * sbuild/sbuild-util.h: Add missing typecast to fix FTBFS on
    GNU/kFreeBSD (Closes: #465972).  Thanks to Petr Salinger.
  * Building with G++ 4.3 now works (Closes: #467457).
  * dchroot.1 manual page no longer specifies -d as a short option for
    directory; this is only used for --preserve-environment
    (Closes: #476815).
  * schroot-mount now creates the mountpoint is not existent
    (Closes: #469038).  Many thanks to Kees Cook for this patch.

 -- Roger Leigh <rleigh@debian.org>  Mon, 05 May 2008 00:09:41 +0100

schroot (1.1.6-1) unstable; urgency=low

  * New upstream development release.
  * Acknowledge NMU.  Thanks to Lucas Nussbaum for fixing the Boost
    library names following another incompatible change in Boost
    (Closes: #439215).
  * debian/control: Suggest lvm2 instead of lvm-common (Closes: #452263).
  * debian/copyright:
    - Update with new GIT source code repository location.
    - Update licence to GPLv3.
  * debian/schroot.init: Update licence to GPLv3.
  * bin/schroot/setup/20network, bin/schroot/setup/30passwd: For files to
    copy, compare file device, inode and contents to avoid copying
    identical files (Closes: #428808).


=== debian/control ===
Source: schroot
Section: admin
Priority: optional
Maintainer: Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>, Luk Claes <luk@debian.org>, Roger Leigh <rleigh@debian.org>, Francesco Paolo Lovergine <frankie@debian.org>
Build-Depends: debhelper (>= 7.0.0), autotools-dev, pkg-config (>= 0.20), libpam0g-dev (>= 0.79-3.1), uuid-dev, liblockdev1-dev (>= 1.0.2), libboost1.37-dev (>= 1.34.0), libboost-program-options1.37-dev (>= 1.34.0), libboost-regex1.37-dev (>= 1.34.0), libboost-filesystem1.37-dev (>= 1.34.0), gettext, libcppunit-dev, doxygen, graphviz
Standards-Version: 3.8.2
Vcs-Browser: http://git.debian.org/?p=buildd-tools/schroot.git
Vcs-Git: git://git.debian.org/git/buildd-tools/schroot

Package: schroot-common
Architecture: all
Replaces: schroot (<< 1.1.1)
Description: common files for schroot
 schroot allows users to execute commands or interactive shells in
 different chroots.  Any number of named chroots may be created, and
 access permissions given to each, including root access for normal
 users, on a per-user or per-group basis.  Additionally, schroot can
 switch to a different user in the chroot, using PAM for
 authentication and authorisation.  All operations are logged for
 security.
 .
 This package provides translations for localisation of schroot
 programs.

Package: libsbuild-dev
Architecture: any
Section: libdevel
Depends: pkg-config (>= 0.14.0)
Suggests: schroot-dbg, libsbuild-doc
Description: development files for the Debian source builder
 sbuild provides facilities to manage and access chroots, as part of
 schroot.
 .
 schroot allows users to execute commands or interactive shells in
 different chroots.  Any number of named chroots may be created, and
 access permissions given to each, including root access for normal
 users, on a per-user or per-group basis.  Additionally, schroot can
 switch to a different user in the chroot, using PAM for
 authentication and authorisation.  All operations are logged for
 security.
 .
 This package contains the header files and static library needed to
 develop applications which make use of sbuild.  Once the API and ABI
 are stable, a shared library will replace the static library.

Package: schroot-dbg
Architecture: any
Section: debug
Priority: extra
Depends: schroot (= ${binary:Version}) | dchroot (= ${binary:Version}) 
 | dchroot-dsa (= ${binary:Version})
Conflicts: schroot (<< ${binary:Version}), schroot (>> ${binary:Version}),
 dchroot (<< ${binary:Version}), dchroot (>>${binary:Version}),
 dchroot-dsa (<< ${binary:Version}), dchroot-dsa (>>${binary:Version})
Description: schroot, dchroot and dchroot-dsa debuggging symbols
 sbuild provides facilities to manage and access chroots, as part of
 schroot.
 .
 schroot allows users to execute commands or interactive shells in
 different chroots.  Any number of named chroots may be created, and
 access permissions given to each, including root access for normal
 users, on a per-user or per-group basis.  Additionally, schroot can
 switch to a different user in the chroot, using PAM for
 authentication and authorisation.  All operations are logged for
 security.
 .
 This package contains debugging symbols for the schroot, dchroot
 and dchroot-dsa packages.

Package: libsbuild-doc
Architecture: all
Section: doc
Suggests: libsbuild-dev
Description: development documentation for the Debian source builder
 sbuild provides facilities to manage and access chroots, as part of
 schroot.
 .
 schroot allows users to execute commands or interactive shells in
 different chroots.  Any number of named chroots may be created, and
 access permissions given to each, including root access for normal
 users, on a per-user or per-group basis.  Additionally, schroot can
 switch to a different user in the chroot, using PAM for
 authentication and authorisation.  All operations are logged for
 security.
 .
 This package contains the API documentation needed to develop
 applications which make use of sbuild.

Package: schroot
Architecture: any
Depends: ${shlibs:Depends}, schroot-common (=${source:Version})
Conflicts: dchroot (<< 0.13)
Enhances: sbuild
Suggests: debootstrap, lvm2, unzip, aufs-modules | unionfs-modules
Description: Execute commands in a chroot environment
 schroot allows users to execute commands or interactive shells in
 different chroots.  Any number of named chroots may be created, and
 access permissions given to each, including root access for normal
 users, on a per-user or per-group basis.  Additionally, schroot can
 switch to a different user in the chroot, using PAM for
 authentication and authorisation.  All operations are logged for
 security.
 .
 Several different types of chroot are supported, including normal
 directories in the filesystem, and also block devices.  Sessions,
 persistent chroots created on the fly from files (tar with optional
 compression and zip) and LVM snapshots are also supported.
 .
 schroot supports kernel personalities, allowing the programs run
 inside the chroot to have a different personality.  For example,
 running 32-bit chroots on 64-bit systems, or even running binaries
 from alternative operating systems such as SVR4 or Xenix.
 .
 schroot also integrates with sbuild, to allow building packages with
 all supported chroot types, including session-managed chroot types
 such as LVM snapshots.
 .
 schroot shares most of its options with dchroot, but offers vastly
 more functionality.

Package: dchroot
Architecture: any
Suggests: debootstrap
Depends: schroot (= ${binary:Version}), ${shlibs:Depends}, schroot-common (=${source:Version})
Description: Execute commands in a chroot environment
 dchroot allows users to execute commands or interactive shells in
 different chroots.  A typical installation might provide 'stable',
 'testing' and 'unstable' chroots.  Users can move between chroots as
 necessary.
 .
 NOTE: the schroot package provides a better implementation of
 dchroot.  In particular:
  * dchroot quoting issues are not present.  dchroot runs commands in
    the chroot with -c option of the user's default shell; when
    multiple command options are used, the options are concatenated
    together, separated by spaces.  This concatenation breaks shell
    quoting.
  * schroot implements fine-grained access controls based on users
    and groups, either of which may be granted the ability to gain
    root access to the chroot if required.
 Using schroot will avoid these issues, as well as provide additional
 functionality dchroot does not possess.

Package: dchroot-dsa
Architecture: any
Suggests: debootstrap
Depends: schroot (= ${binary:Version}), ${shlibs:Depends}, schroot-common (=${source:Version})
Description: Execute commands in a chroot environment
 dchroot allows users to execute commands or interactive shells in
 different chroots.  A typical installation might provide 'stable',
 'testing' and 'unstable' chroots.  Users can move between chroots as
 necessary.
 .
 This package provides a dchroot-dsa binary which is compatible with
 the command-line options and configuration file format used by the
 dchroot-dsa dchroot maintained by the Debian System Administrators
 used on machines administered for the Debian Project.
 .
 NOTE: the schroot package provides a better implementation of
 dchroot-dsa.  In particular:
  * dchroot-dsa only allows the specification of a single command with
    an absolute path, and no options may be used with the command;
    schroot allows the use of relative and absolute paths with no
    limit on the number of options.
  * dchroot-dsa only allows one chroot to be used at once; schroot will
    allow the use of as many chroots as desired.
  * dchroot-dsa allows access to be restricted to named users; schroot
    implements finer-grained access controls based on users and groups,
    either of which may be granted the ability to gain root access to
    the chroot if required.
 Using schroot will avoid these issues, as well as provide significant
 additional functionality dchroot-dsa does not possess.

## schroot 1.3.0-0geofft1

=== debian/changelog ===
schroot (1.3.0-0geofft1) karmic; urgency=low

  * git pull to c840bc3. This includes the official release of schroot
    1.3.0.
  * Fix /etc/setup.d/00check to permit union mounts of the root
    partition.

 -- Geoffrey Thomas <geofft@mit.edu>  Sat, 24 Oct 2009 02:53:47 -0400

schroot (1.2.3-1) unstable; urgency=low

  * New upstream stable release.
  * Detect and link against new versions of the Boost C++ libraries.

 -- Roger Leigh <rleigh@debian.org>  Sun, 17 May 2009 18:29:44 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>
 Uploaders: Michael Banck <mbanck@debian.org>, Luk Claes <luk@debian.org>, Roger Leigh <rleigh@debian.org>, Francesco Paolo Lovergine <frankie@debian.org>
-Build-Depends: debhelper (>= 7.0.0), autotools-dev, pkg-config (>= 0.20), libpam0g-dev (>= 0.79-3.1), uuid-dev, liblockdev1-dev (>= 1.0.2), libboost1.37-dev (>= 1.34.0), libboost-program-options1.37-dev (>= 1.34.0), libboost-regex1.37-dev (>= 1.34.0), libboost-filesystem1.37-dev (>= 1.34.0), gettext, libcppunit-dev, doxygen, graphviz
-Standards-Version: 3.8.2
+Build-Depends: debhelper (>= 7.0.0), autotools-dev, pkg-config (>= 0.20), libpam0g-dev (>= 0.79-3.1), uuid-dev, liblockdev1-dev (>= 1.0.2), libboost1.37-dev (>= 1.37.0), libboost-program-options1.37-dev (>= 1.37.0), libboost-regex1.37-dev (>= 1.37.0), libboost-filesystem1.37-dev (>= 1.37.0), gettext, libcppunit-dev, doxygen, graphviz
+Standards-Version: 3.8.3
 Vcs-Browser: http://git.debian.org/?p=buildd-tools/schroot.git
 Vcs-Git: git://git.debian.org/git/buildd-tools/schroot

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

debian/build/config.status: configure
	dh_testdir

	[ -d debian/build ] || mkdir debian/build

	cd debian/build; \
	CFLAGS="$(CFLAGS)" ../../configure \
	  --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) \
	  --prefix=/usr \
	  --sysconfdir=/etc \
	  --libexecdir=/usr/lib \
	  --localstatedir=/var \
	  --mandir=\$${prefix}/share/man \
	  --infodir=\$${prefix}/share/info \
	  --enable-dchroot --enable-dchroot-dsa \
	  --enable-doxygen \
	  --enable-static --disable-shared \
	  --with-bash-completion-dir=/etc/bash_completion.d

build: build-stamp

build-stamp: debian/build/config.status
	dh_testdir
	$(MAKE) -C debian/build all
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -rf debian/build
	rm -rf debian/install
	rm -f build-stamp

ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub scripts/config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess scripts/config.guess
endif

	dh_clean

check: build
	dh_testdir
	dh_testroot
	$(MAKE) -C debian/build check

install: check
	dh_testdir
	dh_testroot
	dh_prep
	rm -rf debian/install

	dh_installdirs

	$(MAKE) -C debian/build install DESTDIR=$(CURDIR)/debian/install
	dh_install

	mkdir -p $(CURDIR)/debian/dchroot/usr/share/lintian/overrides
	mkdir -p $(CURDIR)/debian/dchroot-dsa/usr/share/lintian/overrides
	mkdir -p $(CURDIR)/debian/schroot/usr/share/lintian/overrides
	cp $(CURDIR)/debian/dchroot.lintian-overrides $(CURDIR)/debian/dchroot/usr/share/lintian/overrides/dchroot
	cp $(CURDIR)/debian/dchroot-dsa.lintian-overrides $(CURDIR)/debian/dchroot-dsa/usr/share/lintian/overrides/dchroot-dsa
	cp $(CURDIR)/debian/schroot.lintian-overrides $(CURDIR)/debian/schroot/usr/share/lintian/overrides/schroot

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_installchangelogs -i ChangeLog
	dh_installdocs -i
	find $(CURDIR)/debian/libsbuild-doc/usr/share/doc/libsbuild-doc -name '*.map' -print0 | xargs -0 rm -f
	find $(CURDIR)/debian/libsbuild-doc/usr/share/doc/libsbuild-doc -name '*.md5' -print0 | xargs -0 rm -f
	dh_installexamples -i
	dh_installman -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a ChangeLog
	dh_installdocs -a
	rm -rf $(CURDIR)/debian/dchroot/usr/share/doc/dchroot
	ln -sf schroot $(CURDIR)/debian/dchroot/usr/share/doc/dchroot
	rm -rf $(CURDIR)/debian/dchroot-dsa/usr/share/doc/dchroot-dsa
	ln -sf schroot $(CURDIR)/debian/dchroot-dsa/usr/share/doc/dchroot-dsa
	dh_installexamples -a
	dh_installman -a
	dh_installinit -a --no-start --update-rcd-params='start 75 S .'
	dh_link -a
	dh_strip -a --dbg-package=schroot-dbg
	dh_compress -a
	dh_fixperms -a
	chmod 4755 $(CURDIR)/debian/dchroot/usr/bin/dchroot
	chmod 4755 $(CURDIR)/debian/dchroot-dsa/usr/bin/dchroot-dsa
	chmod 4755 $(CURDIR)/debian/schroot/usr/bin/schroot
	dh_makeshlibs -a
	dh_installdeb -a
	dh_shlibdeps -a -L libsbuild1 -l$(CURDIR)/debian/libsbuild1/usr/lib
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build check clean binary-indep binary-arch binary install

## schroot 1.4.7

=== debian/changelog ===
schroot (1.4.7-1) unstable; urgency=low

  * New upstream stable release.
  * Use standards version 3.9.0.
  * Correctly distribute profile conffiles (Closes: #588247).  Thanks
    to Mario Holbe.
  * Update it and zh_CN translations.  Thanks to Vincenzo Campanella
    and Ji ZhengYu.

 -- Roger Leigh <rleigh@debian.org>  Tue, 06 Jul 2010 23:34:30 +0100

schroot (1.4.6-1) unstable; urgency=low

  * New upstream stable release.
  * New configuration key preserve-environment allows preservation of
    the environment for a chroot without needing to use the
    --preserve-environment option.
  * The desktop configuration profile no longer bind mounts /var/run;
    gdm3 users will need to comment out the necessary bind mount
    in /etc/schroot/desktop/fstab.
  * schroot.conf(5) documents some additional suggestions for
    desktop users using the desktop profile.
  * schroot: Include common-data and common-functions.
  * Btrfs snapshot session cleanup now works under all circumstances
    (Closes: #587757).  Thanks to Bastian Blank.
  * Session cleanup following session startup failure no longer leaves
    stray session files in place (Closes: #587769).  Thanks to Bastian
    Blank.
  * Trying to run or end a nonexistent session with the same name as
    a chroot now fails outright rather than giving a cryptic error
    message (Closes: #588155).  Thanks to Bastian Blank.

 -- Roger Leigh <rleigh@debian.org>  Mon, 05 Jul 2010 22:13:58 +0100

schroot (1.4.5-1) unstable; urgency=low

  * New upstream stable release.
  * Support for btrfs-snapshot chroots has been merged from the
    master branch.  Note that btrfs is experimental, so the
    configuration options and setup script interface may not yet
    be stable.
  * Add source-clone configuration key to disable source chroots
    (Closes: #576541).  Thanks to Andreas Barth.
  * Add support for Btrfs snapshots (Closes: #477788).  Thanks to
    Martin F. Krafft and Andreas Barth for the idea.
  * Add configuration profiles, including a desktop profile.  This
    allows running of X programs when gdm3 is used by the host by
    bind mounting /var/run (Closes: #586333).  Thanks to Stefano
    Zacchiroli for the suggestion.
  * sbuild::unique_identifier() does not use formatted dates in the
    absence of a UUID function and hence does not use characters
    such as ':' that make lvcreate choke (Closes: #583504).  Thanks
    to Zach Carter.
  * 20nssdatabases: Cope with destination database file not pre-
    existing in the chroot (Closes: #586198).  Thanks to Bastian Blank
    for this patch.  A similar patch has been applied to the file
    checking in 20copyfiles.
  * The default message verbosity may be set on a per-chroot basis
    with the message-verbosity configuration key (Closes: #462453).
  * Frequently asked questions are now addressed in schroot-faq(7).

 -- Roger Leigh <rleigh@debian.org>  Sat, 26 Jun 2010 23:46:08 +0100

schroot (1.4.4-1) unstable; urgency=low

  * Correct personality checks in testsuite for non-Linux
    architectures (Closes: #585653).  Thanks to Cyril Brulebois
    for finding the bug and testing the fix.

 -- Roger Leigh <rleigh@debian.org>  Sat, 12 Jun 2010 23:23:35 +0100

schroot (1.4.3-1) unstable; urgency=low

  * Don't use personality(2) to introspect the set personality, by
    caching the set personality instead.  This avoids problems when
    the kernel sets additional personality flags which prevents
    correct identification of the set personality, currently
    preventing building on ARM (Closes: #580136).
  * Correctly clean up the session when schroot receives SIGINT
    (Closes: #477770).  Thanks to Nathaniel W. Turner for this patch.
  * Add contrib 10mount-ssh setup script (Closes: #574723).  Thanks
    to Sascha Silbe.
  * Add contrib 09fsck setup script (Closes: #492316).  Thanks to
    Martin F. Krafft.
  * Use the '3.0 (quilt)' source format.

 -- Roger Leigh <rleigh@debian.org>  Sat, 12 Jun 2010 16:02:11 +0100

schroot (1.4.2-1) unstable; urgency=low

  * Update fr translation (Closes: #571328).  Thanks to Thomas Blein.
  * Update de translation (Closes: #577554).  Thanks to Holger Wansing.
  * Remove inactive maintainers from uploaders (Closes: #573869).
  * Add support for kFreeBSD platform (Closes: #566513).  Thanks to
    Aurelien Jarno.
  * Support building with Boost 1.42 (Closes: #579701).  Thanks to
    Andy Bailey.

 -- Roger Leigh <rleigh@debian.org>  Tue, 13 Apr 2010 14:22:13 +0100

schroot (1.4.1-2) unstable; urgency=low

  * Create compatibility symlinks for the old setup script
    configuration files in postinst, and remove in postrm.  While
    not strictly needed for starting sessions, these are required
    for recovery of existing sessions which have references to the
    old names.

 -- Roger Leigh <rleigh@debian.org>  Sun, 21 Feb 2010 10:56:59 +0000

schroot (1.4.1-1) unstable; urgency=low

  * New upstream stable release.
  * dchroot and dchroot-dsa now allow root to access chroots which
    don't specifically grant root access in their configuration
    (Closes: #566879).  Thanks to Aurelien Jarno for reporting this.
    This was a regression from the separation of authentication into
    separate PAM and NULL authentication methods used by schroot and
    dchroot/dchroot-dsa, respectively.  The NULL authentication method
    was unnecessarily strict for user authentication.
  * schroot no longer segfaults when loading plain chroot session
    files (Closes: #568187).  This was caused by the chroot
    configuration loader automatically creating a session chroot
    from the template chroot used to deserialise the session
    configuration into.  plain chroots, however, don't support
    session creation and so return a NULL chroot, leading to a
    subsequent segfault.  Thanks to Marc Bantle for identifying this
    regression and aiding in debugging.
  * Enable PAM conversation handler to allow password entry


=== debian/control ===
--- 
+++ 
@@ -2,14 +2,15 @@
 Section: admin
 Priority: optional
 Maintainer: Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>
-Uploaders: Michael Banck <mbanck@debian.org>, Luk Claes <luk@debian.org>, Roger Leigh <rleigh@debian.org>, Francesco Paolo Lovergine <frankie@debian.org>
-Build-Depends: debhelper (>= 7.0.0), autotools-dev, pkg-config (>= 0.20), libpam0g-dev (>= 0.79-3.1), uuid-dev, liblockdev1-dev (>= 1.0.2), libboost1.37-dev (>= 1.37.0), libboost-program-options1.37-dev (>= 1.37.0), libboost-regex1.37-dev (>= 1.37.0), libboost-filesystem1.37-dev (>= 1.37.0), gettext, libcppunit-dev, doxygen, graphviz
-Standards-Version: 3.8.3
+Uploaders: Roger Leigh <rleigh@debian.org>
+Build-Depends: debhelper (>= 7.0.0), autotools-dev, pkg-config (>= 0.20), libpam0g-dev (>= 0.79-3.1), uuid-dev, liblockdev1-dev (>= 1.0.2), libboost-dev (>= 1.39.0), libboost-program-options-dev (>= 1.39.0), libboost-regex-dev (>= 1.39.0), libboost-filesystem-dev (>= 1.39.0), gettext, libcppunit-dev, doxygen, graphviz
+Standards-Version: 3.9.0
 Vcs-Browser: http://git.debian.org/?p=buildd-tools/schroot.git
 Vcs-Git: git://git.debian.org/git/buildd-tools/schroot
 
 Package: schroot-common
 Architecture: all
+Depends: ${misc:Depends}
 Replaces: schroot (<< 1.1.1)
 Description: common files for schroot
  schroot allows users to execute commands or interactive shells in
@@ -26,7 +27,7 @@
 Package: libsbuild-dev
 Architecture: any
 Section: libdevel
-Depends: pkg-config (>= 0.14.0)
+Depends: ${misc:Depends}, pkg-config (>= 0.14.0)
 Suggests: schroot-dbg, libsbuild-doc
 Description: development files for the Debian source builder
  sbuild provides facilities to manage and access chroots, as part of
@@ -48,7 +49,7 @@
 Architecture: any
 Section: debug
 Priority: extra
-Depends: schroot (= ${binary:Version}) | dchroot (= ${binary:Version}) 
+Depends: ${misc:Depends}, schroot (= ${binary:Version}) | dchroot (= ${binary:Version}) 
  | dchroot-dsa (= ${binary:Version})
 Conflicts: schroot (<< ${binary:Version}), schroot (>> ${binary:Version}),
  dchroot (<< ${binary:Version}), dchroot (>>${binary:Version}),
@@ -71,6 +72,7 @@
 Package: libsbuild-doc
 Architecture: all
 Section: doc
+Depends: ${misc:Depends}
 Suggests: libsbuild-dev
 Description: development documentation for the Debian source builder
  sbuild provides facilities to manage and access chroots, as part of
@@ -89,10 +91,10 @@
 
 Package: schroot
 Architecture: any
-Depends: ${shlibs:Depends}, schroot-common (=${source:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, schroot-common (=${source:Version})
 Conflicts: dchroot (<< 0.13)
 Enhances: sbuild
-Suggests: debootstrap, lvm2, unzip, aufs-modules | unionfs-modules
+Suggests: debootstrap, lvm2, btrfs-tools, unzip, aufs-modules | unionfs-modules
 Description: Execute commands in a chroot environment
  schroot allows users to execute commands or interactive shells in
  different chroots.  Any number of named chroots may be created, and
@@ -122,7 +124,7 @@
 Package: dchroot
 Architecture: any
 Suggests: debootstrap
-Depends: schroot (= ${binary:Version}), ${shlibs:Depends}, schroot-common (=${source:Version})
+Depends: ${misc:Depends}, schroot (= ${binary:Version}), ${shlibs:Depends}, schroot-common (=${source:Version})
 Description: Execute commands in a chroot environment
  dchroot allows users to execute commands or interactive shells in
  different chroots.  A typical installation might provide 'stable',
@@ -145,7 +147,7 @@
 Package: dchroot-dsa
 Architecture: any
 Suggests: debootstrap
-Depends: schroot (= ${binary:Version}), ${shlibs:Depends}, schroot-common (=${source:Version})
+Depends: ${misc:Depends}, schroot (= ${binary:Version}), ${shlibs:Depends}, schroot-common (=${source:Version})
 Description: Execute commands in a chroot environment
  dchroot allows users to execute commands or interactive shells in
  different chroots.  A typical installation might provide 'stable',

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,15 @@
 # from having to guess our platform (since we know it already)
 DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
+DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
 
+ifneq ($(DEB_HOST_ARCH_OS),linux)
+	LVMSNAP_OPTIONS = --disable-lvm-snapshot
+	BTRFSSNAP_OPTIONS = --disable-btrfs-snapshot
+else
+	LVMSNAP_OPTIONS = --enable-lvm-snapshot
+	BTRFSSNAP_OPTIONS = --enable-btrfs-snapshot
+endif
 
 CFLAGS = -Wall -g
 
@@ -36,7 +44,11 @@
 	  --enable-dchroot --enable-dchroot-dsa \
 	  --enable-doxygen \
 	  --enable-static --disable-shared \
-	  --with-bash-completion-dir=/etc/bash_completion.d
+	  --with-bash-completion-dir=/etc/bash_completion.d \
+	  $(LVMSNAP_OPTIONS) $(BTRFSSNAP_OPTIONS) \
+	  BTRFS=/sbin/btrfs \
+	  BTRFSCTL=/sbin/btrfsctl \
+	  LVCREATE=/sbin/lvcreate
 
 build: build-stamp

## schroot 1.4.19

=== debian/changelog ===
schroot (1.4.19-1~bpo50+3) lenny-backports; urgency=low

  * Backport for lenny.
  * sbuild/*.cc: Use sbuild:: for all file scope usage of chroot type.
    As for sbuild/sbuild-chroot.cc, using chroot:: rather than
    sbuild::chroot, causes a misbuild on the alpha architecture.

 -- Roger Leigh <rleigh@debian.org>  Tue, 18 Jan 2011 21:13:20 +0000

schroot (1.4.19-1~bpo50+2) lenny-backports; urgency=low

  * Backport for lenny.
  * sbuild/sbuild-chroot.cc: Use sbuild:: namespace for all file scope
    definitions.  Some definitions used chroot:: rather than
    sbuild::chroot, which was causing a misbuild on the alpha
    architecture.

 -- Roger Leigh <rleigh@debian.org>  Mon, 17 Jan 2011 23:56:48 +0000

schroot (1.4.19-1~bpo50+1) lenny-backports; urgency=low

  * Backport for lenny.
  * schroot-dbg is in section devel (no debug section in lenny).
  * configure.ac: Revert Boost library checks to correctly link with
    the lenny libraries.

 -- Roger Leigh <rleigh@debian.org>  Sun, 16 Jan 2011 10:20:57 +0000

schroot (1.4.19-1) unstable; urgency=low

  * New upstream stable release.
  * bin/dchroot-dsa/dchroot-dsa-session.cc: Don't include <uuid/uuid.h>.
    This isn't required and breaks building on kfreebsd where we don't
    build-depend on uuid-dev (Closes: #609619).

 -- Roger Leigh <rleigh@debian.org>  Tue, 11 Jan 2011 00:11:26 +0000

schroot (1.4.18-1) unstable; urgency=low

  * New upstream stable release.
  * Disable the use of long UUIDs in automatically-generated session
    names on kfreebsd kernels (Closes: #609108).  Use the time and
    process ID instead, which are far shorter than the UUID.  This is
    required due to FreeBSD kernels using fixed-length character arrays
    in their struct statfs structure which limits the mount and umount
    commands to paths less than 88 characters in length (80 in
    practice).  Disabling UUID support reduces the likelihood of mount
    and umount failure when beginning and ending sessions, but can not
    fix the underlying bug in FreeBSD.  It can still be triggered if
    long session names are used, or filesystems are mounted deep inside
    the chroot directory hierarchy.  Thanks to Guillem Jover, Julián
    Moreno Patiño and Jakub Wilk for help fixing the configure script,
    Debian packaging and testing.
  * 50chrootname: Strip time+PID from session name in addition to UUID.
    This sets /etc/debian_chroot correctly (without automatically
    generated suffix) on kfreebsd platforms.

 -- Roger Leigh <rleigh@debian.org>  Fri, 07 Jan 2011 14:49:31 +0000

schroot (1.4.17-1) unstable; urgency=low

  * New upstream stable release.
  * 15killprocs: Don't kill processes in other sessions
    (Closes: #608054).  Compare full chroot path in addition to device
    and inode numbers, since the device and inode are not sufficiently
    unique (they are shared between non-cloned sessions such as for
    directory type chroots).
  * Updated translations:
    - da (Closes: #606305).  Thanks to Joe Hansen.
    - de (Closes: #606245).  Thanks to Holger Wansing.
    - fr (Closes: #606394).  Thanks to Thomas Blein.
    - it.  Thanks to Vincenzo Campanella.
    - zh_CN.  Thanks to Ji ZhengYu.

 -- Roger Leigh <rleigh@debian.org>  Wed, 29 Dec 2010 16:41:30 +0000

schroot (1.4.16-1) unstable; urgency=low

  * New upstream stable release.
  * Document schroot -- option delimiter in schroot(1)
    (Closes: #599380).
  * Document security implications of bind-mounting /dev and other
    filesystems in schroot.conf(5) (Closes: #587758).
  * Relax chroot naming restrictions (Closes: #601043, #605939).  The
    name may not contain a leading period (‘.’).  The  characters ‘:’
    (colon), ‘,’ (comma) and ‘/’ (forward slash) are not permitted
    anywhere in the name.  The name may also not contain a trailing
    tilde ('~').  Otherwise any characters are permitted.
  * 10mount: Respect mount options from configuration for all mountable
    chroot types (Closes: #605950).  Thanks to Nelson Elhage for this
    patch.
  * 15killprocs: Improve performance by omitting a readlink call for
    each process running on the system, leading to a significant
    reduction in overhead on busy systems (Closes: #606162).  Thanks
    to Anders Kaseorg for this patch.

 -- Roger Leigh <rleigh@debian.org>  Tue, 07 Dec 2010 12:29:25 +0000

schroot (1.4.15-1~bpo50+1) lenny-backports; urgency=low

  * Backport for lenny.
  * schroot-dbg is in section devel (no debug section in lenny).
  * configure.ac: Revert Boost library checks to correctly link with
    the lenny libraries.

 -- Roger Leigh <rleigh@debian.org>  Sun, 07 Nov 2010 23:27:29 +0000

schroot (1.4.15-1) unstable; urgency=low

  * New upstream stable release.
  * 10mount: Always purge mount directory for file type chroots
    (Closes: #600966).  file chroots are now unpacked into a
    separate unpack directory and then bind mounted into the
    mount directory, making this special casing redundant and
    causing stray session directories to be left in the mount
    directory.
  * schroot.NEWS: Document incompatible changes introduced in
    1.4.0 and 1.4.1 (Closes: #597778).

 -- Roger Leigh <rleigh@debian.org>  Fri, 22 Oct 2010 22:18:34 +0100

schroot (1.4.14-1) unstable; urgency=low

  * New upstream stable release.
  * Updated translations:
    - vi (Closes: #598353).  Thanks to Clytie Siddall.

 -- Roger Leigh <rleigh@debian.org>  Sun, 03 Oct 2010 11:57:08 +0100

schroot (1.4.13-1) unstable; urgency=low

  * Session actions work with plain chroots again (Closes: #597368).
    Because plain chroots are not session-capable, actions such as
    --run-session and --end-session, which look for chroots in the
    "session" namespace, don't find plain chroots, which only exist
    in the "chroot" namespace.  To work around this limitation,
    proxy sessions are created as aliases in the session namespace
    to allow session actions to work for plain chroots.
  * Correct error handing for --all options:


=== debian/control ===
--- 
+++ 
@@ -3,8 +3,9 @@
 Priority: optional
 Maintainer: Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>
 Uploaders: Roger Leigh <rleigh@debian.org>
-Build-Depends: debhelper (>= 7.0.0), autotools-dev, pkg-config (>= 0.20), libpam0g-dev (>= 0.79-3.1), uuid-dev, liblockdev1-dev (>= 1.0.2), libboost-dev (>= 1.39.0), libboost-program-options-dev (>= 1.39.0), libboost-regex-dev (>= 1.39.0), libboost-filesystem-dev (>= 1.39.0), gettext, libcppunit-dev, doxygen, graphviz
-Standards-Version: 3.9.0
+Build-Depends: debhelper (>= 7.0.0), autotools-dev, pkg-config (>= 0.20), libpam0g-dev (>= 0.79-3.1), uuid-dev [!kfreebsd-any], liblockdev1-dev (>= 1.0.2), libboost-dev (>= 1.34.0), libboost-program-options-dev (>= 1.34.0), libboost-regex-dev (>= 1.34.0), libboost-filesystem-dev (>= 1.34.0), gettext, libcppunit-dev
+Build-Depends-Indep: doxygen, graphviz
+Standards-Version: 3.9.1
 Vcs-Browser: http://git.debian.org/?p=buildd-tools/schroot.git
 Vcs-Git: git://git.debian.org/git/buildd-tools/schroot
 
@@ -47,9 +48,9 @@
 
 Package: schroot-dbg
 Architecture: any
-Section: debug
+Section: devel
 Priority: extra
-Depends: ${misc:Depends}, schroot (= ${binary:Version}) | dchroot (= ${binary:Version}) 
+Depends: ${misc:Depends}, schroot (= ${binary:Version}) | dchroot (= ${binary:Version})
  | dchroot-dsa (= ${binary:Version})
 Conflicts: schroot (<< ${binary:Version}), schroot (>> ${binary:Version}),
  dchroot (<< ${binary:Version}), dchroot (>>${binary:Version}),
